package bpiwowar.argparser;


/**
 * Exception class used by <code>ArgParser</code> when command line arguments
 * contain an error.
 * 
 * @see ArgParser
 */
public class ArgParseException extends ArgParserException {
	private static final long serialVersionUID = 7811830362301494380L;

	/**
	 * Creates a new ArgParseException with the given message.
	 * 
	 * @param msg
	 *            Exception message
	 */
	public ArgParseException(String msg) {
		super(msg);
	}

	/**
	 * Creates a new ArgParseException from the given argument and message.
	 * 
	 * @param arg
	 *            Offending argument
	 * @param msg
	 *            Error message
	 */
	public ArgParseException(String format, Object ... args) {
		super(String.format(format, args));
	}


	public ArgParseException(Throwable cause, String format, Object... args) { 
		super(String.format(format, args), cause);
	}
}
