package bpiwowar.argparser;

import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;

import bpiwowar.argparser.handlers.Handler;

/**
 * Used to assign a handler to an arbitrary class
 * 
 * <pre>
 *  &#x40;ArgumentHandler(IntegerHandler.class)
 *  class PositiveInteger extends Integer {
 *  ...
 *  }
 * </pre>
 * 
 * @author Benjamin Piwowarski <benjamin@bpiwowar.net>
 */
@Retention(RetentionPolicy.RUNTIME)
public @interface ArgumentHandler {
	Class<? extends Handler> value();
}
