/**
 * 
 */
package bpiwowar.argparser;

import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

/**
 * Annotation for (non-static) methods of option objects that should be called (in order
 * to test argument values). Such a method can throw an ArgParseException or and 
 * {@link IllegalArgumentValue}.
 * 
 * @author B. Piwowarski
 * @since 1.0
 *
 */
@Retention(value = RetentionPolicy.RUNTIME)
@Target(ElementType.METHOD)
public @interface ArgumentPostProcessor {
}
