/**
 * 
 */
package bpiwowar.argparser;

import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

/**
 * Annotation for enumeration values
 * 
 */
@Retention(value = RetentionPolicy.RUNTIME)
@Target(value = { ElementType.FIELD })
public @interface EnumValue {
	/** The argument value (can have several) */
	String[] value();
	
	/** The help string for the value */
	String help() default "";
}
