/**
 * 
 */
package bpiwowar.argparser;

/**
 * Exception thrown when an argument has a not valid value (i.e., value out of bound, etc.)
 * 
 * @author B. Piwowarski
 * @date 30/08/2007
 */
@SuppressWarnings("serial")
public class IllegalArgumentValue extends ArgParserException {
	String field;
	
	public void setField(String field) {
		this.field = field;
	}

	@Override
	public String toString() {
		if (field == null)
			return super.toString();

		return String.format("Error while processing option %s:%n%s", field,
				super.toString());
	}

	/**
	 * @param e
	 */
	public IllegalArgumentValue(String s) {
		super(s);
	}

	/**
	 * @param e
	 */
	public IllegalArgumentValue(Exception e) {
		this(e.toString());
	}

	/**
	 * @param string
	 * @param e
	 */
	public IllegalArgumentValue(String s, Throwable e) {
		super(s, e);
	}

	/**
	 * Construct the exception using string formatting
	 * 
	 * @param format
	 *            The format string
	 * @param values
	 *            The values
	 */
	public IllegalArgumentValue(String format, Object... values) {
		super(String.format(format, values));
	}

}
