/**
 * 
 */
package bpiwowar.argparser;

/**
 * Exception thrown when the holder is not valid for the member type
 * @author Benjamin Piwowarski
 */
public class InvalidHolderException extends RuntimeException {
	private static final long serialVersionUID = 1L;

	/**
	 * @param cause
	 */
	public InvalidHolderException(Throwable cause) {
		super(cause);
	}

	/**
	 * @param e
	 */
	public InvalidHolderException(Exception e) {
		this(e.toString());
	}

	/**
	 * @param string
	 * @param e
	 */
	public InvalidHolderException(String s, Throwable e) {
		super(s,e);
	}
	
	public InvalidHolderException(String format, Throwable t, Object... args) {
		super(String.format(format, args), t);
	}
	
	public InvalidHolderException(String format, Object... args) {
		super(String.format(format, args));
	}

}
