package bpiwowar.argparser;

import java.lang.annotation.Annotation;
import java.util.HashMap;

import bpiwowar.argparser.utils.AnnotationMap;

/**
 * An annotation map provided by a list
 * 
 * @author B. Piwowarski <benjamin@bpiwowar.net>
 */
public class ListAnnotationMap implements AnnotationMap {
	private HashMap<Class<?>, Annotation> map = new HashMap<Class<?>, Annotation>();

	public ListAnnotationMap(Annotation[] list) {
		for (Annotation a : list) {
			map.put(a.annotationType(), a);
		}
	}

	@SuppressWarnings("unchecked")
	public <T extends Annotation> T getAnnotation(Class<T> annotationClass) {
		return (T) map.get(annotationClass);
	}
}