/**
 * 
 */
package bpiwowar.argparser;

import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;

import bpiwowar.argparser.handlers.Handler;


/**
 * A command line argument description for ordered arguments
 * To check integrity, use {@link PostChecker}
 * 
 * @author B. Piwowarski
 * @date 30/08/2007
 *
 */
@Retention(value = RetentionPolicy.RUNTIME)
public @interface OrderedArgument {
    /** The name of the option (only used when building the help string) */
    String name() default "";
    
    /** Required? */
    boolean required() default false;

    /** The help string */
    String help() default "";
	
	/** Fully qualified name of the wrapper object */
	Class<? extends Handler> handler() default Handler.class;

	/** The valid intervals of values 
	 * Example: [0,1),(2,3] 
	 */
	String [] intervals() default {};

}
