package bpiwowar.argparser;

import java.io.IOException;

/**
 * Exception class used by <code>StringScanner</code> when command line
 * arguments do not parse correctly.
 * 
 * @author John E. Lloyd, Winter 2001
 * @see StringScanner
 */
public class StringScanException extends ArgParserException {
	private static final long serialVersionUID = 1L;
	int failIdx;

	public StringScanException() {
		super();
	}

	public StringScanException(String message, Throwable cause) {
		super(message, cause);
	}

	public StringScanException(Throwable cause) {
		super(cause);
	}
	
	public StringScanException(String format, Object... args) {
		super(String.format(format, args));
	}

	public StringScanException(String format, Throwable cause, Object... args) {
		super(String.format(format, args), cause);
	}

	/**
	 * Creates a new StringScanException with the given message.
	 * 
	 * @param msg
	 *            Error message
	 * @see StringScanner
	 */

	public StringScanException(String msg) {
		super(msg);
	}

	public StringScanException(int idx, String msg) {
		super(msg);
		failIdx = idx;
	}

	public int getFailIndex() {
		return failIdx;
	}
}
