package bpiwowar.argparser;

import java.lang.reflect.Type;
import java.util.Arrays;

import bpiwowar.argparser.ArgParser.TypeCheckerInterface;

/**
 * Default type checker, that accepts a pre-defined set of classes
 * 
 * @author Benjamin Piwowarski <benjamin@bpiwowar.net>
 */
public class TypeChecker implements TypeCheckerInterface {
	final Class<?>[] classes;

	TypeChecker(Class<?>... classes) {
		this.classes = classes;
	}

	public boolean isCompatible(Type type) {
		for (Class<?> candidate : classes) {
			if (candidate.isAssignableFrom(Handlers.getTypeClass(type)))
				return true;
		}
		return false;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString() {
		return "Type checker of " + Arrays.toString(classes);
	}
}