/**
 * 
 */
package bpiwowar.argparser.checkers;


/**
 * @author bpiwowar
 * @date Nov 29, 2007
 *
 */
public class DoubleLimit extends Limit {
	
	private double value;

	public DoubleLimit(Type type, double value) {
		super(type);
		this.value = value;
	}

	/**
	 * Constructs from a double
	 * @param d
	 */
	public DoubleLimit(double d) {
		this(Type.UNKNOWN, d);
	}

	/* (non-Javadoc)
	 * @see yrla.argparser.checkers.Checker#check()
	 */
	public int compareTo(Object object) {
		if (object instanceof Double)
			return Double.compare(value, (Double)object);
		else if (object instanceof Float)
			return Float.compare((float)value, (Float)object);
		throw new ClassCastException("Cannot compare a double to " + object.getClass());
	}

	/* (non-Javadoc)
	 * @see yrla.argparser.checkers.Limit#toString()
	 */
	@Override
	public String toString() {
		return super.toString() + "  " + value;
	}
	
	/* (non-Javadoc)
	 * @see yrla.argparser.checkers.ValueChecker#getDescription()
	 */
	public String getDescription() {
		return super.getDescription() + " "+ value;
	}
}
