/**
 * 
 */
package bpiwowar.argparser.checkers;


/**
 * @author bpiwowar
 * @date Nov 29, 2007
 *
 */
public class LongLimit extends Limit {
	
	private Long value;

	public LongLimit(Type type, long value) {
		super(type);
		this.value = value;
	}

	/**
	 * Constructs from a double
	 * @param d
	 */
	public LongLimit(long d) {
		this(Type.UNKNOWN, d);
	}

	/* (non-Javadoc)
	 * @see yrla.argparser.checkers.Checker#check()
	 */
	public int compareTo(Object object) {
		
		if (object instanceof Long)
			return value.compareTo((Long)object);
		else if (object instanceof Integer)
			return value.compareTo((long)((Integer)object));
		throw new ClassCastException("Cannot compare a double to " + object.getClass());
	}

	/* (non-Javadoc)
	 * @see yrla.argparser.checkers.Limit#toString()
	 */
	@Override
	public String toString() {
		return super.toString() + " for " + value;
	}
	
	/* (non-Javadoc)
	 * @see yrla.argparser.checkers.ValueChecker#getDescription()
	 */
	public String getDescription() {
		return super.toString();
	}
}
