package bpiwowar.argparser.handlers;

import java.lang.reflect.Field;
import java.util.ArrayList;
import java.util.Collection;

import bpiwowar.argparser.ArgParser;
import bpiwowar.argparser.InvalidHolderException;
import bpiwowar.argparser.StringScanException;

/**
 * The argument is a set of characters
 * @author Benjamin Piwowarski <benjamin@bpiwowar.net>
 */
public class CharSetHandler extends GenericObjectsHandler {
	public CharSetHandler(Object object, Field field)
			throws InvalidHolderException {
		super(object, field, ArrayList.class);
		if (!Collection.class.isAssignableFrom(field.getType()))
			throw new InvalidHolderException(
					"Field %s is not a collection",
					field);
		// TODO: check it implements Collection<? extends String>
		// Type type = field.getGenericType();
	}

	@Override
	protected Object process(ArgParser argParser, String chars)
			throws StringScanException {
		try {
			Collection<Character> set = (Collection<Character>) field
					.get(object);
			for (int i = chars.length() - 1; i >= 0; i--)
				set.add(chars.charAt(i));
			return set;
		} catch (RuntimeException e) {
			throw e;
		} catch (Exception e) {
			throw new StringScanException(e);
		}
	}
}