/**
 * 
 */
package bpiwowar.argparser.handlers;

import java.io.File;
import java.lang.reflect.Field;
import java.util.Map;

import bpiwowar.argparser.ArgParser;
import bpiwowar.argparser.InvalidHolderException;
import bpiwowar.argparser.StringScanException;
import bpiwowar.argparser.StringScanner;
import bpiwowar.argparser.utils.ReadLineIterator;

public class FileStringMapHandler extends GenericObjectsHandler {
	public FileStringMapHandler(Object object, Field field)
			throws InvalidHolderException {
		super(object, field);
		if (!Map.class.isAssignableFrom(field.getType()))
			throw new InvalidHolderException(
					"Field %s is not a collection", field);
		// TODO: check it implements Map<? extends String, ? extends String>
		// Type type = field.getGenericType();
	}

	@Override
	protected Object process(ArgParser argParser, StringScanner scanner)
			throws StringScanException {
		try {
			File file = new File(scanner.scanString());
			Map<String, String> set = (Map<String, String>) field
					.get(object);
			for (String line : new ReadLineIterator(file)) {
				String[] fields = line.split("\t");
				if (line.equals(""))
					continue;

				if (fields.length != 2)
					throw new StringScanException(
							"Line <<<%s>>> has not two tab separated values",
							line);
				set.put(fields[0], fields[1]);
			}
			return set;
		} catch (RuntimeException e) {
			throw e;
		} catch (Exception e) {
			throw new StringScanException(e);
		}
	}
}