package bpiwowar.argparser.handlers;

import java.lang.reflect.Field;

import bpiwowar.argparser.ArgParser;
import bpiwowar.argparser.IllegalArgumentValue;
import bpiwowar.argparser.StringScanException;
import bpiwowar.argparser.StringScanner;


/**
 * A float wrapper
 * 
 * @author bpiwowar
 * @date 30/08/2007
 * 
 */
@HandlerInformation({float.class, Float.class})
public class FloatHandler extends FloatingPointHandler  {

	public FloatHandler(Object object, Field field) {
		super(object, field);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see yrla.argparser.holders.Holder#scan(yrla.argparser.StringScanner)
	 */
	public Object process(ArgParser argParser, StringScanner scanner) throws StringScanException, IllegalArgumentValue {
		final double v = scanner.scanDouble();
		addValue((float)v);
		check(v);
		return v;
	}

}
