/**
 * 
 */
package bpiwowar.argparser.handlers;

import java.lang.reflect.Field;

import bpiwowar.argparser.ArgParser;
import bpiwowar.argparser.IllegalArgumentValue;
import bpiwowar.argparser.StringScanException;
import bpiwowar.argparser.StringScanner;
import bpiwowar.argparser.checkers.Limit;
import bpiwowar.argparser.checkers.LongLimit;


/**
 * @author bpiwowar
 * @date 30/08/2007
 *
 */
@HandlerInformation({int.class, Integer.class})
public class IntHandler extends IntegerHandler {


	public IntHandler(Object object, Field field) {
		super(object, field);
	}
	
	/* (non-Javadoc)
	 * @see yrla.argparser.holders.Holder#scan(yrla.argparser.StringScanner)
	 */
	@Override
	public Object process(ArgParser argParser, StringScanner scanner) throws StringScanException, IllegalArgumentValue {
		Integer v = (int)scanInteger(scanner);
		check(v);
		addValue(v);
		return v;
	}
	
	/* (non-Javadoc)
	 * @see argparser.BooleanHolderInterface#isValue()
	 */
	public int getValue() {
		return (Integer) get();
	}

	/* (non-Javadoc)
	 * @see argparser.BooleanHolderInterface#setValue(boolean)
	 */
	public void setValue(int value) {
		try {
			field.setInt(object, value);
		} catch (Exception e) {
			throw new RuntimeException(e);
		}
	}
	
	/* (non-Javadoc)
	 * @see yrla.argparser.handlers.Handler#getLimitChecker(yrla.argparser.StringScanner)
	 */
	@Override
	public Limit getLimitChecker(StringScanner scanner) throws IllegalArgumentException, StringScanException {
		return new LongLimit(scanner.scanInt());
	}

}
