/**
 * 
 */
package bpiwowar.argparser.handlers;

import java.lang.reflect.Field;
import java.util.regex.Pattern;

import bpiwowar.argparser.ArgParser;
import bpiwowar.argparser.StringScanException;
import bpiwowar.argparser.StringScanner;

/**
 * Pattern handler - basically the same as String handler, but compiles the
 * regular expression
 * 
 * @author B. Piwowarski <benjamin@bpiwowar.net>
 */
@HandlerInformation(Pattern.class)
public class PatternHandler extends GenericObjectsHandler {

	public PatternHandler(Object object, Field field) {
		super(object, field);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see yrla.argparser.holders.Holder#scan(yrla.argparser.StringScanner)
	 */
	public Object process(ArgParser argParser, StringScanner scanner)
			throws StringScanException {
		final String s = scanner.getString();
		addValue(Pattern.compile(s));
		return s;
	}
}
