package bpiwowar.argparser.holders;

/**
 * Wrapper class which ``holds'' an integer value, enabling methods to return
 * integer values through arguments.
 */
public class IntHolder extends Holder<Integer> implements java.io.Serializable {
	private static final long serialVersionUID = 1L;
	
	/**
	 * Value of the integer, set and examined by the application as needed.
	 */
	private int value;

	/**
	 * Constructs a new <code>IntHolder</code> with an initial value of 0.
	 */
	public IntHolder() {
		setValue(0);
	}

	/**
	 * Constructs a new <code>IntHolder</code> with a specific initial value.
	 * 
	 * @param i
	 *            Initial integer value.
	 */
	public IntHolder(int i) {
		setValue(i);
	}

	public void setValue(String value) {
		this.value = Integer.parseInt(value);
	}

	public void setValue(int value) {
		this.value = value;
	}

	/* (non-Javadoc)
	 * @see bpiwowar.argparser.holders.Holder#getValue()
	 */
	public Integer getValue() {
		return value;
	}
}
