package bpiwowar.argparser.holders;


/**
 * Wrapper class which ``holds'' a long value, enabling methods to return long
 * values through arguments.
 */
public class LongHolder implements java.io.Serializable {
	/**
	 * 
	 */
	private static final long serialVersionUID = -9008916102686318016L;
	/**
	 * Value of the long, set and examined by the application as needed.
	 */
	private long value;

	/*
	 * (non-Javadoc)
	 * 
	 * @see yrla.argparser.holders.LongHolderInterface#getValue()
	 */
	public long getValue() {
		return value;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see yrla.argparser.holders.LongHolderInterface#setValue(long)
	 */
	public void setValue(long value) {
		this.value = value;
	}

	/**
	 * Constructs a new <code>LongHolder</code> with an initial value of 0.
	 */
	public LongHolder() {
		value = 0;
	}

	/**
	 * Constructs a new <code>LongHolder</code> with a specific initial value.
	 * 
	 * @param l
	 *            Initial long value.
	 */
	public LongHolder(long l) {
		value = l;
	}
}
