package bpiwowar.argparser.utils;

import java.io.Serializable;

/**
 * A pair of objects
 * 
 * @author Benjamin Piwowarski
 * @date 16/01/2007
 */
final public class Pair<T extends Object, U extends Object> implements Serializable {
	private static final long serialVersionUID = -4235368324324509377L;
	
	/**
	 * First element of the pair 
	 */
	private T first;
	
	
	/**
	 * Second element of the pair 
	 */
	private U second;
	
	
	public Pair() {
	}

	public Pair(final T x, final U y) {
		this.first = x;
		this.second = y;
	}

	public final T getFirst() {
		return first;
	}

	public final void setFirst(final T x) {
		this.first = x;
	}

	public final U getSecond() {
		return second;
	}

	public final void setSecond(final U y) {
		this.second = y;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString() {
		return String.format("(%s,%s)", first, second);
	}

}
