package bpiwowar.experiments;

import java.io.IOException;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.util.Arrays;

import bpiwowar.argparser.ArgParseException;
import bpiwowar.argparser.Logger;

@TaskDescription(name = "run", project = { "main" })
public class RunClass implements Task {
	final static private Logger logger = Logger.getLogger();

	private String[] args;

	private Method method;

	/**
	 * @param args
	 * @throws InvocationTargetException
	 * @throws IllegalAccessException
	 * @throws IllegalArgumentException
	 * @throws IOException
	 */
	@Override
	public int run() throws IllegalArgumentException, IllegalAccessException,
			InvocationTargetException {
		method.invoke(null, new Object[] { args });
		return 0;
	}

	@Override
	public void init(String[] args) throws Exception {
		if (args.length == 0)
			throw new ArgParseException(
					"Expected at least one argument (the class name)");
		final String className = args[0];
		this.args = Arrays.copyOfRange(args, 1, args.length);
		logger.info("Loading class %s", className);
		Class<?> loadClass = getClass().getClassLoader().loadClass(className);
		method = loadClass.getMethod("main", String[].class);

	}

}
