package bpiwowar.experiments;

import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

/**
 * Defines an experiment
 * 
 * @author Benjamin Piwowarski <benjamin@bpiwowar.net>
 */
@Retention(value = RetentionPolicy.RUNTIME)
@Target(ElementType.TYPE)
public @interface TaskDescription {
	/** The name of the experiment */
	String name();
	
	/** The project the experiment belongs to (including subproject, ordered from the most specific to the most general) */
	String[] project();

	/**
	 * The task description
	 */
	String description() default "";

}
